#ifndef EFL_CANVAS_GROUP_EO_HH
#define EFL_CANVAS_GROUP_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
#include "efl_canvas_group.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_key.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_gfx.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_gfx_size_hint.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_input_interface.eo.h"
#include "eo_base.eo.h"
#include "eo_interface.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_event_hold.eo.hh"
#include "efl_event_key.eo.hh"
#include "efl_event_pointer.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_gfx_map.eo.hh"
#include "efl_gfx_size_hint.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_input_interface.eo.hh"
#include "eo_base.eo.hh"
#include "eo_interface.eo.hh"
namespace efl { namespace canvas { 
struct Group;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::canvas::Group> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace canvas { 
struct Group {
   ::efl::eolian::return_traits<bool>::type group_need_recalculate_get() const;
   ::efl::eolian::return_traits<void>::type group_need_recalculate_set( ::efl::eolian::in_traits<bool>::type value) const;
   ::efl::eolian::return_traits<void>::type group_clip_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type clip) const;
   ::efl::eolian::return_traits<void>::type group_color_set( ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   ::efl::eolian::return_traits<void>::type group_no_render_set( ::efl::eolian::in_traits<bool>::type hide) const;
   ::efl::eolian::return_traits<void>::type group_change() const;
   ::efl::eolian::return_traits<void>::type group_children_move( ::efl::eolian::in_traits<int>::type dx,  ::efl::eolian::in_traits<int>::type dy) const;
   ::efl::eolian::return_traits<void>::type group_calculate() const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::Gfx>>::type group_children_iterate() const;
   ::efl::eolian::return_traits<void>::type group_show() const;
   ::efl::eolian::return_traits<void>::type group_move( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y) const;
   ::efl::eolian::return_traits<void>::type group_hide() const;
   ::efl::eolian::return_traits<void>::type group_add() const;
   ::efl::eolian::return_traits<void>::type group_member_add( ::efl::eolian::in_traits< ::efl::canvas::Object>::type sub_obj) const;
   ::efl::eolian::return_traits<void>::type group_resize( ::efl::eolian::in_traits<Evas_Coord>::type w,  ::efl::eolian::in_traits<Evas_Coord>::type h) const;
   ::efl::eolian::return_traits<void>::type group_clip_unset() const;
   ::efl::eolian::return_traits<void>::type group_member_del( ::efl::eolian::in_traits< ::efl::canvas::Object>::type sub_obj) const;
   ::efl::eolian::return_traits<void>::type group_del() const;
   static Eo_Class const* _eo_class()
   {
      return EFL_CANVAS_GROUP_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::canvas::Group() const;
   operator ::efl::canvas::Group&();
   operator ::efl::canvas::Group const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Group,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Group const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace canvas { 
struct Group : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl ::canvas::Object)
   , EO_CXX_INHERIT( ::efl ::gfx::Map)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::gfx ::size::Hint)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::eo::Interface)
{
   explicit Group( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Group(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Group(Group const& other) = default;
   Group(Group&& other) = default;
   Group& operator=(Group const& other) = default;
   Group& operator=(Group&& other) = default;
   Group()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Group( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Group(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<bool>::type group_need_recalculate_get() const;
   ::efl::eolian::return_traits<void>::type group_need_recalculate_set( ::efl::eolian::in_traits<bool>::type value) const;
   ::efl::eolian::return_traits<void>::type group_clip_set( ::efl::eolian::in_traits< ::efl::canvas::Object>::type clip) const;
   ::efl::eolian::return_traits<void>::type group_color_set( ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   ::efl::eolian::return_traits<void>::type group_no_render_set( ::efl::eolian::in_traits<bool>::type hide) const;
   ::efl::eolian::return_traits<void>::type group_change() const;
   ::efl::eolian::return_traits<void>::type group_children_move( ::efl::eolian::in_traits<int>::type dx,  ::efl::eolian::in_traits<int>::type dy) const;
   ::efl::eolian::return_traits<void>::type group_calculate() const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::Gfx>>::type group_children_iterate() const;
   ::efl::eolian::return_traits<void>::type group_show() const;
   ::efl::eolian::return_traits<void>::type group_move( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y) const;
   ::efl::eolian::return_traits<void>::type group_hide() const;
   ::efl::eolian::return_traits<void>::type group_add() const;
   ::efl::eolian::return_traits<void>::type group_member_add( ::efl::eolian::in_traits< ::efl::canvas::Object>::type sub_obj) const;
   ::efl::eolian::return_traits<void>::type group_resize( ::efl::eolian::in_traits<Evas_Coord>::type w,  ::efl::eolian::in_traits<Evas_Coord>::type h) const;
   ::efl::eolian::return_traits<void>::type group_clip_unset() const;
   ::efl::eolian::return_traits<void>::type group_member_del( ::efl::eolian::in_traits< ::efl::canvas::Object>::type sub_obj) const;
   ::efl::eolian::return_traits<void>::type group_del() const;
   static Eo_Class const* _eo_class()
   {
      return EFL_CANVAS_GROUP_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Group,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Group const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Group) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Group>::value, "");
} } 
#include "efl_canvas_group.eo.impl.hh"
#endif
