#ifndef EFL_CANVAS_POLYGON_EO_HH
#define EFL_CANVAS_POLYGON_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_canvas_polygon.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_key.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_gfx.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_gfx_size_hint.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_input_interface.eo.h"
#include "eo_base.eo.h"
#include "eo_interface.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_event_hold.eo.hh"
#include "efl_event_key.eo.hh"
#include "efl_event_pointer.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_gfx_map.eo.hh"
#include "efl_gfx_size_hint.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_input_interface.eo.hh"
#include "eo_base.eo.hh"
#include "eo_interface.eo.hh"
namespace efl { namespace canvas { 
struct Polygon;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::canvas::Polygon> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace canvas { 
struct Polygon {
   ::efl::eolian::return_traits<void>::type point_add( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y) const;
   ::efl::eolian::return_traits<void>::type points_clear() const;
   static Eo_Class const* _eo_class()
   {
      return EFL_CANVAS_POLYGON_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::canvas::Polygon() const;
   operator ::efl::canvas::Polygon&();
   operator ::efl::canvas::Polygon const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Polygon,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Polygon const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace canvas { 
struct Polygon : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl ::canvas::Object)
   , EO_CXX_INHERIT( ::efl ::gfx::Map)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::gfx ::size::Hint)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::eo::Interface)
{
   explicit Polygon( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Polygon(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Polygon(Polygon const& other) = default;
   Polygon(Polygon&& other) = default;
   Polygon& operator=(Polygon const& other) = default;
   Polygon& operator=(Polygon&& other) = default;
   Polygon()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Polygon( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Polygon(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<void>::type point_add( ::efl::eolian::in_traits<Evas_Coord>::type x,  ::efl::eolian::in_traits<Evas_Coord>::type y) const;
   ::efl::eolian::return_traits<void>::type points_clear() const;
   static Eo_Class const* _eo_class()
   {
      return EFL_CANVAS_POLYGON_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Polygon,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Polygon const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Polygon) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Polygon>::value, "");
} } 
#include "efl_canvas_polygon.eo.impl.hh"
#endif
