#ifndef EVAS_CANVAS3D_NODE_EO_HH
#define EVAS_CANVAS3D_NODE_EO_HH
#include <Eo.h>

extern "C" {
#include "eo_base.eo.h"
#include "evas_canvas3d_light.eo.h"
#include "evas_canvas3d_mesh.eo.h"
#include "evas_canvas3d_node.eo.h"
#include "evas_canvas3d_object.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "eo_base.eo.hh"
#include "evas_canvas3d_light.eo.hh"
#include "evas_canvas3d_mesh.eo.hh"
#include "evas_canvas3d_object.eo.hh"
namespace evas { namespace canvas3d { 
struct Node;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Node> : ::std::true_type {}; } }

namespace eo_cxx {
namespace evas { namespace canvas3d { 
struct Node {
   ::efl::eolian::return_traits<bool>::type position_inherit_get() const;
   ::efl::eolian::return_traits<void>::type position_inherit_set( ::efl::eolian::in_traits<bool>::type inherit) const;
   ::efl::eolian::return_traits<bool>::type orientation_inherit_get() const;
   ::efl::eolian::return_traits<void>::type orientation_inherit_set( ::efl::eolian::in_traits<bool>::type inherit) const;
   ::efl::eolian::return_traits<bool>::type scale_inherit_get() const;
   ::efl::eolian::return_traits<void>::type scale_inherit_set( ::efl::eolian::in_traits<bool>::type inherit) const;
   ::efl::eolian::return_traits< ::evas::canvas3d::Object>::type camera_get() const;
   ::efl::eolian::return_traits<void>::type camera_set( ::efl::eolian::in_traits< ::evas::canvas3d::Object>::type camera) const;
   ::efl::eolian::return_traits< ::evas::canvas3d::Light>::type light_get() const;
   ::efl::eolian::return_traits<void>::type light_set( ::efl::eolian::in_traits< ::evas::canvas3d::Light>::type light) const;
   ::efl::eolian::return_traits<int>::type mesh_frame_get( ::efl::eolian::in_traits< ::evas::canvas3d::Mesh>::type mesh) const;
   ::efl::eolian::return_traits<void>::type mesh_frame_set( ::efl::eolian::in_traits< ::evas::canvas3d::Mesh>::type mesh,  ::efl::eolian::in_traits<int>::type frame) const;
   ::efl::eolian::return_traits< ::evas::canvas3d::Node>::type billboard_target_get() const;
   ::efl::eolian::return_traits<void>::type billboard_target_set( ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type target) const;
   ::efl::eolian::return_traits<bool>::type lod_enable_get() const;
   ::efl::eolian::return_traits<void>::type lod_enable_set( ::efl::eolian::in_traits<bool>::type enable) const;
   ::efl::eolian::return_traits<void>::type constructor( ::efl::eolian::in_traits<Evas_Canvas3D_Node_Type>::type type) const;
   ::efl::eolian::return_traits<Evas_Canvas3D_Node_Type>::type type_get() const;
   ::efl::eolian::return_traits<void>::type member_add( ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type member) const;
   ::efl::eolian::return_traits<void>::type member_del( ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type member) const;
   ::efl::eolian::return_traits< ::evas::canvas3d::Node>::type parent_get() const;
   ::efl::eolian::return_traits<  ::efl::eina::range_list< ::evas::canvas3d::Node>>::type member_list_get() const;
   ::efl::eolian::return_traits<Eina_Hash*>::type scene_root_get() const;
   ::efl::eolian::return_traits<void>::type position_set( ::efl::eolian::in_traits<Evas_Real>::type x,  ::efl::eolian::in_traits<Evas_Real>::type y,  ::efl::eolian::in_traits<Evas_Real>::type z) const;
   ::efl::eolian::return_traits<void>::type orientation_set( ::efl::eolian::in_traits<Evas_Real>::type x,  ::efl::eolian::in_traits<Evas_Real>::type y,  ::efl::eolian::in_traits<Evas_Real>::type z,  ::efl::eolian::in_traits<Evas_Real>::type w) const;
   ::efl::eolian::return_traits<void>::type orientation_angle_axis_set( ::efl::eolian::in_traits<Evas_Real>::type angle,  ::efl::eolian::in_traits<Evas_Real>::type x,  ::efl::eolian::in_traits<Evas_Real>::type y,  ::efl::eolian::in_traits<Evas_Real>::type z) const;
   ::efl::eolian::return_traits<void>::type scale_set( ::efl::eolian::in_traits<Evas_Real>::type x,  ::efl::eolian::in_traits<Evas_Real>::type y,  ::efl::eolian::in_traits<Evas_Real>::type z) const;
   ::efl::eolian::return_traits<void>::type position_get( ::efl::eolian::in_traits<Evas_Canvas3D_Space>::type space,  ::efl::eolian::out_traits<Evas_Real>::type x,  ::efl::eolian::out_traits<Evas_Real>::type y,  ::efl::eolian::out_traits<Evas_Real>::type z) const;
   ::efl::eolian::return_traits<void>::type orientation_get( ::efl::eolian::in_traits<Evas_Canvas3D_Space>::type space,  ::efl::eolian::out_traits<Evas_Real>::type x,  ::efl::eolian::out_traits<Evas_Real>::type y,  ::efl::eolian::out_traits<Evas_Real>::type z,  ::efl::eolian::out_traits<Evas_Real>::type w) const;
   ::efl::eolian::return_traits<void>::type scale_get( ::efl::eolian::in_traits<Evas_Canvas3D_Space>::type space,  ::efl::eolian::out_traits<Evas_Real>::type x,  ::efl::eolian::out_traits<Evas_Real>::type y,  ::efl::eolian::out_traits<Evas_Real>::type z) const;
   ::efl::eolian::return_traits<void>::type look_at_set( ::efl::eolian::in_traits<Evas_Canvas3D_Space>::type target_space,  ::efl::eolian::in_traits<Evas_Real>::type x,  ::efl::eolian::in_traits<Evas_Real>::type y,  ::efl::eolian::in_traits<Evas_Real>::type z,  ::efl::eolian::in_traits<Evas_Canvas3D_Space>::type up_space,  ::efl::eolian::in_traits<Evas_Real>::type ux,  ::efl::eolian::in_traits<Evas_Real>::type uy,  ::efl::eolian::in_traits<Evas_Real>::type uz) const;
   ::efl::eolian::return_traits<void>::type mesh_add( ::efl::eolian::in_traits< ::evas::canvas3d::Mesh>::type mesh) const;
   ::efl::eolian::return_traits<void>::type mesh_del( ::efl::eolian::in_traits< ::evas::canvas3d::Mesh>::type mesh) const;
   ::efl::eolian::return_traits<  ::efl::eina::range_list< ::evas::canvas3d::Mesh>>::type mesh_list_get() const;
   static Eo_Class const* _eo_class()
   {
      return EVAS_CANVAS3D_NODE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::evas::canvas3d::Node() const;
   operator ::evas::canvas3d::Node&();
   operator ::evas::canvas3d::Node const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Node,  ::eo::Base,  ::evas::canvas3d::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Node const ,  ::eo::Base const ,  ::evas::canvas3d::Object const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace evas { namespace canvas3d { 
struct Node : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::evas ::canvas3d::Object)
{
   explicit Node( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Node(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Node(Node const& other) = default;
   Node(Node&& other) = default;
   Node& operator=(Node const& other) = default;
   Node& operator=(Node&& other) = default;
   Node()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Node( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Node(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<bool>::type position_inherit_get() const;
   ::efl::eolian::return_traits<void>::type position_inherit_set( ::efl::eolian::in_traits<bool>::type inherit) const;
   ::efl::eolian::return_traits<bool>::type orientation_inherit_get() const;
   ::efl::eolian::return_traits<void>::type orientation_inherit_set( ::efl::eolian::in_traits<bool>::type inherit) const;
   ::efl::eolian::return_traits<bool>::type scale_inherit_get() const;
   ::efl::eolian::return_traits<void>::type scale_inherit_set( ::efl::eolian::in_traits<bool>::type inherit) const;
   ::efl::eolian::return_traits< ::evas::canvas3d::Object>::type camera_get() const;
   ::efl::eolian::return_traits<void>::type camera_set( ::efl::eolian::in_traits< ::evas::canvas3d::Object>::type camera) const;
   ::efl::eolian::return_traits< ::evas::canvas3d::Light>::type light_get() const;
   ::efl::eolian::return_traits<void>::type light_set( ::efl::eolian::in_traits< ::evas::canvas3d::Light>::type light) const;
   ::efl::eolian::return_traits<int>::type mesh_frame_get( ::efl::eolian::in_traits< ::evas::canvas3d::Mesh>::type mesh) const;
   ::efl::eolian::return_traits<void>::type mesh_frame_set( ::efl::eolian::in_traits< ::evas::canvas3d::Mesh>::type mesh,  ::efl::eolian::in_traits<int>::type frame) const;
   ::efl::eolian::return_traits< ::evas::canvas3d::Node>::type billboard_target_get() const;
   ::efl::eolian::return_traits<void>::type billboard_target_set( ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type target) const;
   ::efl::eolian::return_traits<bool>::type lod_enable_get() const;
   ::efl::eolian::return_traits<void>::type lod_enable_set( ::efl::eolian::in_traits<bool>::type enable) const;
   ::efl::eolian::return_traits<void>::type constructor( ::efl::eolian::in_traits<Evas_Canvas3D_Node_Type>::type type) const;
   ::efl::eolian::return_traits<Evas_Canvas3D_Node_Type>::type type_get() const;
   ::efl::eolian::return_traits<void>::type member_add( ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type member) const;
   ::efl::eolian::return_traits<void>::type member_del( ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type member) const;
   ::efl::eolian::return_traits< ::evas::canvas3d::Node>::type parent_get() const;
   ::efl::eolian::return_traits<  ::efl::eina::range_list< ::evas::canvas3d::Node>>::type member_list_get() const;
   ::efl::eolian::return_traits<Eina_Hash*>::type scene_root_get() const;
   ::efl::eolian::return_traits<void>::type position_set( ::efl::eolian::in_traits<Evas_Real>::type x,  ::efl::eolian::in_traits<Evas_Real>::type y,  ::efl::eolian::in_traits<Evas_Real>::type z) const;
   ::efl::eolian::return_traits<void>::type orientation_set( ::efl::eolian::in_traits<Evas_Real>::type x,  ::efl::eolian::in_traits<Evas_Real>::type y,  ::efl::eolian::in_traits<Evas_Real>::type z,  ::efl::eolian::in_traits<Evas_Real>::type w) const;
   ::efl::eolian::return_traits<void>::type orientation_angle_axis_set( ::efl::eolian::in_traits<Evas_Real>::type angle,  ::efl::eolian::in_traits<Evas_Real>::type x,  ::efl::eolian::in_traits<Evas_Real>::type y,  ::efl::eolian::in_traits<Evas_Real>::type z) const;
   ::efl::eolian::return_traits<void>::type scale_set( ::efl::eolian::in_traits<Evas_Real>::type x,  ::efl::eolian::in_traits<Evas_Real>::type y,  ::efl::eolian::in_traits<Evas_Real>::type z) const;
   ::efl::eolian::return_traits<void>::type position_get( ::efl::eolian::in_traits<Evas_Canvas3D_Space>::type space,  ::efl::eolian::out_traits<Evas_Real>::type x,  ::efl::eolian::out_traits<Evas_Real>::type y,  ::efl::eolian::out_traits<Evas_Real>::type z) const;
   ::efl::eolian::return_traits<void>::type orientation_get( ::efl::eolian::in_traits<Evas_Canvas3D_Space>::type space,  ::efl::eolian::out_traits<Evas_Real>::type x,  ::efl::eolian::out_traits<Evas_Real>::type y,  ::efl::eolian::out_traits<Evas_Real>::type z,  ::efl::eolian::out_traits<Evas_Real>::type w) const;
   ::efl::eolian::return_traits<void>::type scale_get( ::efl::eolian::in_traits<Evas_Canvas3D_Space>::type space,  ::efl::eolian::out_traits<Evas_Real>::type x,  ::efl::eolian::out_traits<Evas_Real>::type y,  ::efl::eolian::out_traits<Evas_Real>::type z) const;
   ::efl::eolian::return_traits<void>::type look_at_set( ::efl::eolian::in_traits<Evas_Canvas3D_Space>::type target_space,  ::efl::eolian::in_traits<Evas_Real>::type x,  ::efl::eolian::in_traits<Evas_Real>::type y,  ::efl::eolian::in_traits<Evas_Real>::type z,  ::efl::eolian::in_traits<Evas_Canvas3D_Space>::type up_space,  ::efl::eolian::in_traits<Evas_Real>::type ux,  ::efl::eolian::in_traits<Evas_Real>::type uy,  ::efl::eolian::in_traits<Evas_Real>::type uz) const;
   ::efl::eolian::return_traits<void>::type mesh_add( ::efl::eolian::in_traits< ::evas::canvas3d::Mesh>::type mesh) const;
   ::efl::eolian::return_traits<void>::type mesh_del( ::efl::eolian::in_traits< ::evas::canvas3d::Mesh>::type mesh) const;
   ::efl::eolian::return_traits<  ::efl::eina::range_list< ::evas::canvas3d::Mesh>>::type mesh_list_get() const;
   static Eo_Class const* _eo_class()
   {
      return EVAS_CANVAS3D_NODE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Node,  ::eo::Base,  ::evas::canvas3d::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Node const ,  ::eo::Base const ,  ::evas::canvas3d::Object const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Node) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Node>::value, "");
} } 
#include "evas_canvas3d_node.eo.impl.hh"
#endif
