#ifndef EVAS_GRID_EO_HH
#define EVAS_GRID_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
#include "efl_canvas_group.eo.h"
#include "efl_canvas_group_clipped.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_key.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_gfx.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_gfx_size_hint.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_input_interface.eo.h"
#include "eo_base.eo.h"
#include "eo_interface.eo.h"
#include "evas_grid.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_canvas_group.eo.hh"
#include "efl_canvas_group_clipped.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_event_hold.eo.hh"
#include "efl_event_key.eo.hh"
#include "efl_event_pointer.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_gfx_map.eo.hh"
#include "efl_gfx_size_hint.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_input_interface.eo.hh"
#include "eo_base.eo.hh"
#include "eo_interface.eo.hh"
namespace evas { 
struct Grid;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::Grid> : ::std::true_type {}; } }

namespace eo_cxx {
namespace evas { 
struct Grid {
   ::efl::eolian::return_traits<bool>::type mirrored_get() const;
   ::efl::eolian::return_traits<void>::type mirrored_set( ::efl::eolian::in_traits<bool>::type mirrored) const;
   ::efl::eolian::return_traits<void>::type size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type size_set( ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   ::efl::eolian::return_traits<  ::efl::eina::list< ::efl::canvas::Object>>::type children_get() const;
   ::efl::eolian::return_traits< ::efl::eina::accessor< ::efl::canvas::Object>>::type accessor_new() const;
   ::efl::eolian::return_traits<void>::type clear( ::efl::eolian::in_traits<bool>::type clear) const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::canvas::Object>>::type iterator_new() const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type add_to() const;
   ::efl::eolian::return_traits<bool>::type unpack( ::efl::eolian::in_traits< ::efl::canvas::Object>::type child) const;
   ::efl::eolian::return_traits<bool>::type pack_get( ::efl::eolian::in_traits< ::efl::canvas::Object>::type child,  ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y,  ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<bool>::type pack( ::efl::eolian::in_traits< ::efl::canvas::Object>::type child,  ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   static Eo_Class const* _eo_class()
   {
      return EVAS_GRID_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::evas::Grid() const;
   operator ::evas::Grid&();
   operator ::evas::Grid const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Grid,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::canvas::group::Clipped,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Grid const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::canvas::group::Clipped const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace evas { 
struct Grid : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl ::canvas::Group)
   , EO_CXX_INHERIT( ::efl ::canvas::Object)
   , EO_CXX_INHERIT( ::efl ::canvas ::group::Clipped)
   , EO_CXX_INHERIT( ::efl ::gfx::Map)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::gfx ::size::Hint)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::eo::Interface)
{
   explicit Grid( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Grid(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Grid(Grid const& other) = default;
   Grid(Grid&& other) = default;
   Grid& operator=(Grid const& other) = default;
   Grid& operator=(Grid&& other) = default;
   Grid()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Grid( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Grid(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<bool>::type mirrored_get() const;
   ::efl::eolian::return_traits<void>::type mirrored_set( ::efl::eolian::in_traits<bool>::type mirrored) const;
   ::efl::eolian::return_traits<void>::type size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type size_set( ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   ::efl::eolian::return_traits<  ::efl::eina::list< ::efl::canvas::Object>>::type children_get() const;
   ::efl::eolian::return_traits< ::efl::eina::accessor< ::efl::canvas::Object>>::type accessor_new() const;
   ::efl::eolian::return_traits<void>::type clear( ::efl::eolian::in_traits<bool>::type clear) const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::canvas::Object>>::type iterator_new() const;
   ::efl::eolian::return_traits< ::efl::canvas::Object>::type add_to() const;
   ::efl::eolian::return_traits<bool>::type unpack( ::efl::eolian::in_traits< ::efl::canvas::Object>::type child) const;
   ::efl::eolian::return_traits<bool>::type pack_get( ::efl::eolian::in_traits< ::efl::canvas::Object>::type child,  ::efl::eolian::out_traits<int>::type x,  ::efl::eolian::out_traits<int>::type y,  ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<bool>::type pack( ::efl::eolian::in_traits< ::efl::canvas::Object>::type child,  ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   static Eo_Class const* _eo_class()
   {
      return EVAS_GRID_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Grid,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Group,  ::efl::canvas::Object,  ::efl::canvas::group::Clipped,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Grid const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Group const ,  ::efl::canvas::Object const ,  ::efl::canvas::group::Clipped const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Grid) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Grid>::value, "");
} 
#include "evas_grid.eo.impl.hh"
#endif
