#ifndef EVAS_TEXTGRID_EO_HH
#define EVAS_TEXTGRID_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_animator.eo.h"
#include "efl_canvas_object.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_key.eo.h"
#include "efl_event_pointer.eo.h"
#include "efl_gfx.eo.h"
#include "efl_gfx_map.eo.h"
#include "efl_gfx_size_hint.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_input_interface.eo.h"
#include "efl_text_properties.eo.h"
#include "eo_base.eo.h"
#include "eo_interface.eo.h"
#include "evas_textgrid.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_animator.eo.hh"
#include "efl_canvas_object.eo.hh"
#include "efl_event_hold.eo.hh"
#include "efl_event_key.eo.hh"
#include "efl_event_pointer.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_gfx_map.eo.hh"
#include "efl_gfx_size_hint.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_input_interface.eo.hh"
#include "efl_text_properties.eo.hh"
#include "eo_base.eo.hh"
#include "eo_interface.eo.hh"
namespace evas { 
struct Textgrid;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::Textgrid> : ::std::true_type {}; } }

namespace eo_cxx {
namespace evas { 
struct Textgrid {
   ::efl::eolian::return_traits<Evas_Textgrid_Font_Style>::type supported_font_styles_get() const;
   ::efl::eolian::return_traits<void>::type supported_font_styles_set( ::efl::eolian::in_traits<Evas_Textgrid_Font_Style>::type styles) const;
   ::efl::eolian::return_traits<void>::type size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type size_set( ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type cell_size_get( ::efl::eolian::out_traits<int>::type width,  ::efl::eolian::out_traits<int>::type height) const;
   ::efl::eolian::return_traits<void>::type update_add( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type palette_set( ::efl::eolian::in_traits<Evas_Textgrid_Palette>::type pal,  ::efl::eolian::in_traits<int>::type idx,  ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   ::efl::eolian::return_traits<void>::type palette_get( ::efl::eolian::in_traits<Evas_Textgrid_Palette>::type pal,  ::efl::eolian::in_traits<int>::type idx,  ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   static Eo_Class const* _eo_class()
   {
      return EVAS_TEXTGRID_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::evas::Textgrid() const;
   operator ::evas::Textgrid&();
   operator ::evas::Textgrid const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Textgrid,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::efl::text::Properties,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Textgrid const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::efl::text::Properties const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace evas { 
struct Textgrid : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Animator)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl ::canvas::Object)
   , EO_CXX_INHERIT( ::efl ::gfx::Map)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::efl ::gfx ::size::Hint)
   , EO_CXX_INHERIT( ::efl ::input::Interface)
   , EO_CXX_INHERIT( ::efl ::text::Properties)
   , EO_CXX_INHERIT( ::eo::Base)
   , EO_CXX_INHERIT( ::eo::Interface)
{
   explicit Textgrid( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Textgrid(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Textgrid(Textgrid const& other) = default;
   Textgrid(Textgrid&& other) = default;
   Textgrid& operator=(Textgrid const& other) = default;
   Textgrid& operator=(Textgrid&& other) = default;
   Textgrid()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Textgrid( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Textgrid(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<Evas_Textgrid_Font_Style>::type supported_font_styles_get() const;
   ::efl::eolian::return_traits<void>::type supported_font_styles_set( ::efl::eolian::in_traits<Evas_Textgrid_Font_Style>::type styles) const;
   ::efl::eolian::return_traits<void>::type size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type size_set( ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type cell_size_get( ::efl::eolian::out_traits<int>::type width,  ::efl::eolian::out_traits<int>::type height) const;
   ::efl::eolian::return_traits<void>::type update_add( ::efl::eolian::in_traits<int>::type x,  ::efl::eolian::in_traits<int>::type y,  ::efl::eolian::in_traits<int>::type w,  ::efl::eolian::in_traits<int>::type h) const;
   ::efl::eolian::return_traits<void>::type palette_set( ::efl::eolian::in_traits<Evas_Textgrid_Palette>::type pal,  ::efl::eolian::in_traits<int>::type idx,  ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type g,  ::efl::eolian::in_traits<int>::type b,  ::efl::eolian::in_traits<int>::type a) const;
   ::efl::eolian::return_traits<void>::type palette_get( ::efl::eolian::in_traits<Evas_Textgrid_Palette>::type pal,  ::efl::eolian::in_traits<int>::type idx,  ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type g,  ::efl::eolian::out_traits<int>::type b,  ::efl::eolian::out_traits<int>::type a) const;
   static Eo_Class const* _eo_class()
   {
      return EVAS_TEXTGRID_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Textgrid,  ::efl::Animator,  ::efl::Gfx,  ::efl::canvas::Object,  ::efl::gfx::Map,  ::efl::gfx::Stack,  ::efl::gfx::size::Hint,  ::efl::input::Interface,  ::efl::text::Properties,  ::eo::Base,  ::eo::Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Textgrid const ,  ::efl::Animator const ,  ::efl::Gfx const ,  ::efl::canvas::Object const ,  ::efl::gfx::Map const ,  ::efl::gfx::Stack const ,  ::efl::gfx::size::Hint const ,  ::efl::input::Interface const ,  ::efl::text::Properties const ,  ::eo::Base const ,  ::eo::Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Textgrid) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Textgrid>::value, "");
} 
#include "evas_textgrid.eo.impl.hh"
#endif
